<?php

namespace BadgerCMS\UI\Controller\Admin;

use BadgerCMS\Application\Command\User\DeleteUser\DeleteUserCommand;
use BadgerCMS\Application\Command\User\EditUser\EditUserCommand;
use BadgerCMS\Domain\User\User;
use Doctrine\ORM\EntityManagerInterface;
use EasyCorp\Bundle\EasyAdminBundle\Config\Action;
use EasyCorp\Bundle\EasyAdminBundle\Config\Actions;
use EasyCorp\Bundle\EasyAdminBundle\Config\Crud;
use EasyCorp\Bundle\EasyAdminBundle\Controller\AbstractCrudController;
use EasyCorp\Bundle\EasyAdminBundle\Field\BooleanField;
use EasyCorp\Bundle\EasyAdminBundle\Field\ChoiceField;
use EasyCorp\Bundle\EasyAdminBundle\Field\EmailField;
use EasyCorp\Bundle\EasyAdminBundle\Field\IdField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use Ramsey\Uuid\Uuid;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;

class UserCrudController extends AbstractCrudController
{

    public static function getEntityFqcn(): string
    {
        return User::class;
    }

    public function configureCrud(Crud $crud): Crud
    {
        return $crud
            ->setEntityPermission('ROLE_ADMIN')
            ->setEntityLabelInSingular('Użytkownik')
            ->setEntityLabelInPlural('Użytkownicy');
    }

    public function configureActions(Actions $actions): Actions
    {
        $versionAction = Action::new(EntityVersionController::ACTION_NAME, false, 'fa fa-history')
            ->linkToRoute('admin_entity_version', function (User $user){
                return [
                    'entityClassName' => User::class,
                    'entityId' => $user->getId()
                ];
            });

        $actions->update(
            Crud::PAGE_INDEX,
            Action::EDIT,
            fn(Action $action) => $action->setIcon('fa fa-edit')->setLabel(false)
        )
            ->update(
                Crud::PAGE_INDEX,
                Action::DELETE,
                fn(Action $action) => $action->setIcon('fa fa-trash')->setLabel(false)
            )
            ->update(
                Crud::PAGE_INDEX,
                Action::NEW,
                fn(Action $action) => $action->setLabel('Dodaj użytkownika')
            )
            ->add(
                Crud::PAGE_INDEX,
                Action::DETAIL
            )
            ->update(
                Crud::PAGE_INDEX,
                Action::DETAIL,
                fn(Action  $action) => $action->setIcon('fa fa-eye')->setLabel(false)
            )
            ->add(Crud::PAGE_INDEX, $versionAction)
        ;

        return parent::configureActions($actions); // TODO: Change the autogenerated stub
    }


    public function configureFields(string $pageName): iterable
    {
        return [
            IdField::new('id')->hideOnForm(),
            EmailField::new('email'),
            TextField::new('login'),
            TextField::new('password')
                ->setFormType(RepeatedType::class)
                ->setFormTypeOption('type', PasswordType::class)
                ->setFormTypeOption('required', false)
                ->setFormTypeOption('first_options', ['attr' => ['placeholder' => 'Hasło'], 'label' => 'Hasło'])
                ->setFormTypeOption('second_options', ['attr' => ['placeholder' => 'Powtórz hasło'], 'label' => 'Powtórz hasło'])
                ->onlyOnForms(),
            TextField::new('name')->hideOnIndex(),
            TextField::new('surname')->hideOnIndex(),
            BooleanField::new('active')->hideOnIndex(),
            BooleanField::new('blocked')->hideOnIndex(),
            ChoiceField::new('role')
                ->setChoices(
                    [
                        'Administrator' => 'ROLE_ADMIN',
                        'Moderator' => 'ROLE_MODERATOR',
                        'Użytkownik' => 'ROLE_USER',
                    ]
                )
                ->setCssClass('multiple-select')
                ->allowMultipleChoices(),
        ];
    }

    public function createEntity(string $entityFqcn)
    {
        $user = User::create(
            Uuid::uuid4(),
            '',
            '',
            [],
            '',
        );

        return $user;
    }

    public function persistEntity(EntityManagerInterface $entityManager, $entityInstance): void
    {
        $createUserCommand = new EditUserCommand($entityInstance);
        $this->dispatchMessage($createUserCommand);
    }

    public function updateEntity(EntityManagerInterface $entityManager, $entityInstance): void
    {
        $editUserCommand = new EditUserCommand($entityInstance);
        $this->dispatchMessage($editUserCommand);
    }

    public function deleteEntity(EntityManagerInterface $entityManager, $entityInstance): void
    {
        $deleteUserCommand = new DeleteUserCommand($entityInstance);
        $this->dispatchMessage($deleteUserCommand);
    }


}
